
// Globals
var pgmComboBox;
var custComboBox;
var phaseComboBox;
var busaComboBox;
var perfSysComboBox;
var stateComboBox;
var visLvlComboBox;
var pgmGrid;
var effectStart;
var effectEnd;
   var shortNmElem = new LiberalName("ShortNm", "SHORT NAME", 14);
   var fullNmElem = new LiberalName("FullNm", "FULL NAME", 28);
   var descrElem = new Description("Descr", "DESCRIPTION", 80);
   var effectStartElem = new NonNullElement("EffectStart", "EFFECT START");
   var effectEndElem = new NonNullElement("EffectEnd", "EFFECT END");

function Program() {
   this.id;
   this.shortNm;
   this.fullNm;
   this.descr;
   this.cust;
   this.phase;
   this.camp;
   this.effectStart;
   this.effectEnd;
   this.modDtm;
   this.personModr;
   this.state;
   this.visLvl;
   this.busArea;
   this.perfSys;
   this.mgmntPlan;
   this.rptCrd;
   
   this.alertAll = function() {
   alert("pgm.id=" + this.id + "\n"
        +"pgm.shortNm=" + this.shortNm + "\n"
        +"pgm.descr=" + this.descr + "\n"
        +"pgm.cust=" + this.cust + "\n"
        +"pgm.phase=" + this.phase + "\n"
        +"pgm.camp=" + this.camp + "\n"
        +"pgm.effectStart=" + this.effectStart + "\n"
        +"pgm.effectEnd=" + this.effectEnd + "\n"
        +"pgm.modDtm=" + this.modDtm + "\n"
        +"pgm.personModr=" + this.personModr + "\n"
        +"pgm.state=" + this.state + "\n"
        +"pgm.visLvl=" + this.visLvl + "\n"
        +"pgm.busArea=" + this.busArea + "\n"
        +"pgm.perfSys=" + this.perfSys + "\n"
        +"pgm.mgmntPlan=" + this.mgmntPlan + "\n"
        +"pgm.rptCrd=" + this.rptCrd + "\n");		
   }
   
}

var pgm = new Program();
		   
function doOnCheck() {}
function doOnCellEdit() {}

function onKeyPressed(code,ctrl,shift){
   if(code==67 && ctrl){
      //alert("detected ctrl-c");
      pgmGrid.setCSVDelimiter("\t");
      pgmGrid.gridToClipboard();
    }
        
    //if(code==86 && ctrl){
    //    pgmGrid.PasteSelectionFromClipboard();
    //}
        
    return true;
}
function copyToClipboard(){
      pgmGrid.setCSVDelimiter("\t");
      pgmGrid.enableCSVHeader(true);
      pgmGrid.gridToClipboard();
}

function copyBlockToClipboard(){
      pgmGrid.setCSVDelimiter("\t");
      pgmGrid.enableCSVHeader(true);      
      pgmGrid.copyBlockToClipboard();
}

function onloadEvent() {
   window.dhx_globalImgPath="/wlibs/script/dhtmlx/dhtmlxGrid/codebase/imgs/";

   pgmComboBox=new dhtmlXCombo("KeywordCombo","KeywordCombo",200);
   pgmComboBox.enableFilteringMode(true);
   //pgmComboBox.loadXML("/Lighthammer/Illuminator?Connector=&Server=engsys&Service=&Mode=FixedQuery&Method=&CacheDurationUnits=M&CacheDuration=0&IsCachable=false&InlineTransform=http%3A%2F%2Flocalhost%2Fngc%2FXSLT%2FdhtmlxComboTransform.xsl&Param.1=tmse_pgm&Param.2=short_nm&Query=select+distinct%28%5BParam.2%5D%29+as+item+from+%5BParam.1%5D+order+by+%5BParam.2%5D&QueryParams=&NumberFormat=0.00&DateFormat=MM%2Fdd%2Fyyyy+HH%3Amm%3Ass&RowCount=500&Content-Type=text%2Fxml");

   //hideSearchForm();

   pgmGrid = new dhtmlXGridObject('PgmGrid');
   pgmGrid.setImagePath("/wlibs/script/dhtmlx/dhtmlxGrid/codebase/imgs/");
   //pgmGrid.setIconPath("/wlibs/script/dhtmlx/dhtmlxGrid/codebase/imgs/");
   pgmGrid.setHeader("NAME,FULL NAME,SYNOPSIS,CUSTOMER,PHASE,CAMPUS,START,END,LAST MOD,MODR,STATE,L V L,BUS AREA,PERF SYS,P L N,C R D");
   pgmGrid.setColumnIds("NM,FULL,DESCR,PHASE,CAMP,EFF_START_DTM,EFF_END_DTM,MOD)DTM,PERSON_MODR,STATE,VISLVL,BUSA,PERFS,MNGMNT_PLAN,RPT_CRD");
   pgmGrid.setInitWidths("75, 100, 100,60,75,75,70,70, 70, 60, 65, 20, 60, 60, 20, 20");
   pgmGrid.setColAlign("left,left,left,left,left,left,left,left,right,left,left,center,left,left,center,center");
   pgmGrid.setColTypes("ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ch,ch");
   pgmGrid.setColSorting("str,na,na,na,na,na,na,na,na,na,na,na,na,na,na,na");
   
   pgmGrid.enableMultiselect(false);
   pgmGrid.enableColumnMove(true);
   pgmGrid.enableHeaderMenu();
   pgmGrid.enableBlockSelection();

   pgmGrid.attachEvent("onRowSelect",doOnRowSelected);
   pgmGrid.attachEvent("onKeyPress",onKeyPressed);

   pgmGrid.attachEvent("onEditCell",doOnCellEdit);
   //pgmGrid.attachEvent("onEnter",doOnEnter);
   pgmGrid.attachEvent("onCheckbox",doOnCheck);
   //pgmGrid.attachEvent("onBeforeRowDeleted",doBeforeRowDeleted);


   //pgmGrid.setSkin("light");

   pgmGrid.init();
   //pgmGrid.load("/Lighthammer/Illuminator?Connector=&Server=engsys&Service=&Mode=FixedQuery&Method=&CacheDurationUnits=M&CacheDuration=0&IsCachable=false&InlineTransform=http%3A%2F%2Flocalhost%2Fngc%2FXSLT%2FdhtmlxTransform.xsl&Param.1=&Param.2=&Param.3=&Param.4=&Param.5=&Param.6=&Param.7=&Param.8=&Param.9=&Param.10=&Param.11=&Param.12=&Param.13=&Param.14=&Param.15=&Param.16=&Param.17=&Param.18=&Param.19=&Param.20=&Param.21=&Param.22=&Param.23=&Param.24=&Param.25=&Param.26=&Param.27=&Param.28=&Param.29=&Param.30=&Param.31=&Param.32="
   //             + "&Query=select+pgm_id+as+id%2C++tmse_pgm.short_nm%2C+tmse_pgm.full_nm%2C+tmse_pgm.descr%2C+tmse_cust_lt.nm+as+customer%2C+tmse_pgmph_lt.nm+as+phase%2C+tmse_camp_lt.nm+as+campus%2C+%0D%0A+to_char%28eff_start_dtm%2C+%27yyyy-mm-dd%27%29+as+eff_start_dtm%2C+to_char%28eff_end_dtm%2C+%27yyyy-mm-dd%27%29+as+eff_end_dtm%2C+to_char%28tmse_pgm.mod_dtm%2C+%27yyyy-mm-dd+hh24%3Amm%3Ass%27%29%2C+tmse_pgm.person_modr%2C%0D%0A+tmse_state_lt.nm%2C+tmse_vislvl_lt.nm%2C+tmse_busa_lt.nm%2C+tmse_perfs_lt.nm%2C++tmse_pgm.mngmnt_plan_ind%2C+tmse_pgm.rpt_crd_ind%0D%0A++from+tmse_pgm%2C+tmse_pgmph_lt%2C+tmse_camp_lt%2C+tmse_cust_lt%2C+tmse_state_lt%2C+tmse_vislvl_lt%2C+tmse_busa_lt%2C+tmse_perfs_lt%0D%0A+where+%28%28upper%28tmse_pgm.descr%29+like+upper%28%27%25%5BParam.1%5D%25%27%29%29+or+%28upper%28tmse_pgm.short_nm%29+like+upper%28%27%25%5BParam.1%5D%25%27%29%29+or+%28upper%28tmse_pgm.full_nm%29+like+upper%28%27%25%5BParam.1%5D%25%27%29%29%29+and+tmse_pgm.pgmph_id+%3D+tmse_pgmph_lt.pgmph_id+and%0D%0Atmse_pgm.camp_id+%3D+tmse_camp_lt.camp_id++and+tmse_pgm.cust_id+%3D+tmse_cust_lt.cust_id+%0D%0Aand+tmse_pgm.state_id+%3D+tmse_state_lt.state_id+%0D%0Aand+tmse_pgm.vislvl_id+%3D+tmse_vislvl_lt.vislvl_id+%0D%0Aand+tmse_pgm.busa_id+%3D+tmse_busa_lt.busa_id+%0D%0Aand+tmse_pgm.perfs_id+%3D+tmse_perfs_lt.perfs_id+%0D%0Aorder+by+short_nm"
		//		+ "&QueryParams=&NumberFormat=0.00&DateFormat=MM%2Fdd%2Fyyyy+HH%3Amm%3Ass&RowCount=100&Content-Type=text%2Fxml","xml");
   pgmGrid.load("grid.xml");

   custComboBox=new dhtmlXCombo("CustCombo","CustCombo",200);
   //custComboBox.enableFilteringMode(true);
   custComboBox.readonly(true);
   //custComboBox.loadXML("/Lighthammer/Illuminator?Connector=&Server=engsys&Service=&Mode=FixedQuery&Method=&CacheDurationUnits=M&CacheDuration=0&IsCachable=false&InlineTransform=http%3A%2F%2Flocalhost%2Fngc%2FXSLT%2FdhtmlxComboTransform.xsl&Param.1=tmse_cust_lt&Param.2=nm&Param.3=cust_id&Param.4=&Param.5=&Param.6=&Param.7=&Param.8=&Param.9=&Param.10=&Param.11=&Param.12=&Param.13=&Param.14=&Param.15=&Param.16=&Param.17=&Param.18=&Param.19=&Param.20=&Param.21=&Param.22=&Param.23=&Param.24=&Param.25=&Param.26=&Param.27=&Param.28=&Param.29=&Param.30=&Param.31=&Param.32=&Query=select+%5BParam.2%5D+as+ITEM%2C+%5BParam.3%5D+as+ID+from+%5BParam.1%5D+where+enabled_ind+%3D+%271%27+order+by+ordr+asc&QueryParams=&NumberFormat=0.00&DateFormat=MM%2Fdd%2Fyyyy+HH%3Amm%3Ass&RowCount=500&Content-Type=text%2Fxml");

   busaComboBox=new dhtmlXCombo("BusaCombo","BusaCombo",200);
   //busaComboBox.enableFilteringMode(true);
   busaComboBox.readonly(true);
   //busaComboBox.loadXML("/Lighthammer/Illuminator?Connector=&Server=engsys&Service=&Mode=FixedQuery&Method=&CacheDurationUnits=M&CacheDuration=0&IsCachable=false&InlineTransform=http%3A%2F%2Flocalhost%2Fngc%2FXSLT%2FdhtmlxComboTransform.xsl&Param.1=tmse_busa_lt&Param.2=nm&Param.3=busa_id&Param.4=&Param.5=&Param.6=&Param.7=&Param.8=&Param.9=&Param.10=&Param.11=&Param.12=&Param.13=&Param.14=&Param.15=&Param.16=&Param.17=&Param.18=&Param.19=&Param.20=&Param.21=&Param.22=&Param.23=&Param.24=&Param.25=&Param.26=&Param.27=&Param.28=&Param.29=&Param.30=&Param.31=&Param.32=&Query=select+%5BParam.2%5D+as+ITEM%2C+%5BParam.3%5D+as+ID+from+%5BParam.1%5D+where+enabled_ind+%3D+%271%27+order+by+ordr+asc&QueryParams=&NumberFormat=0.00&DateFormat=MM%2Fdd%2Fyyyy+HH%3Amm%3Ass&RowCount=500&Content-Type=text%2Fxml");

   perfSysComboBox=new dhtmlXCombo("PerfSysCombo","PerfSysCombo",200);
   //perfSysComboBox.enableFilteringMode(true);
   perfSysComboBox.readonly(true);
   //perfSysComboBox.loadXML("/Lighthammer/Illuminator?Connector=&Server=engsys&Service=&Mode=FixedQuery&Method=&CacheDurationUnits=M&CacheDuration=0&IsCachable=false&InlineTransform=http%3A%2F%2Flocalhost%2Fngc%2FXSLT%2FdhtmlxComboTransform.xsl&Param.1=tmse_perfs_lt&Param.2=nm&Param.3=perfs_id&Param.4=&Param.5=&Param.6=&Param.7=&Param.8=&Param.9=&Param.10=&Param.11=&Param.12=&Param.13=&Param.14=&Param.15=&Param.16=&Param.17=&Param.18=&Param.19=&Param.20=&Param.21=&Param.22=&Param.23=&Param.24=&Param.25=&Param.26=&Param.27=&Param.28=&Param.29=&Param.30=&Param.31=&Param.32=&Query=select+%5BParam.2%5D+as+ITEM%2C+%5BParam.3%5D+as+ID+from+%5BParam.1%5D+where+enabled_ind+%3D+%271%27+order+by+ordr+asc&QueryParams=&NumberFormat=0.00&DateFormat=MM%2Fdd%2Fyyyy+HH%3Amm%3Ass&RowCount=500&Content-Type=text%2Fxml");

   stateComboBox=new dhtmlXCombo("StateCombo","StateCombo",100);
   //stateComboBox.enableFilteringMode(true);
   stateComboBox.readonly(true);
   //stateComboBox.loadXML("/Lighthammer/Illuminator?Connector=&Server=engsys&Service=&Mode=FixedQuery&Method=&CacheDurationUnits=M&CacheDuration=0&IsCachable=false&InlineTransform=http%3A%2F%2Flocalhost%2Fngc%2FXSLT%2FdhtmlxComboTransform.xsl&Param.1=tmse_state_lt&Param.2=nm&Param.3=state_id&Param.4=&Param.5=&Param.6=&Param.7=&Param.8=&Param.9=&Param.10=&Param.11=&Param.12=&Param.13=&Param.14=&Param.15=&Param.16=&Param.17=&Param.18=&Param.19=&Param.20=&Param.21=&Param.22=&Param.23=&Param.24=&Param.25=&Param.26=&Param.27=&Param.28=&Param.29=&Param.30=&Param.31=&Param.32=&Query=select+%5BParam.2%5D+as+ITEM%2C+%5BParam.3%5D+as+ID+from+%5BParam.1%5D+where+enabled_ind+%3D+%271%27+order+by+ordr+asc&QueryParams=&NumberFormat=0.00&DateFormat=MM%2Fdd%2Fyyyy+HH%3Amm%3Ass&RowCount=500&Content-Type=text%2Fxml");

   visLvlComboBox=new dhtmlXCombo("VisLvlCombo","VisLvlCombo",100);
   //visLvlComboBox.enableFilteringMode(true);
   visLvlComboBox.readonly(true);
   //visLvlComboBox.loadXML("/Lighthammer/Illuminator?Connector=&Server=engsys&Service=&Mode=FixedQuery&Method=&CacheDurationUnits=M&CacheDuration=0&IsCachable=false&InlineTransform=http%3A%2F%2Flocalhost%2Fngc%2FXSLT%2FdhtmlxComboTransform.xsl&Param.1=tmse_vislvl_lt&Param.2=nm&Param.3=vislvl_id&Param.4=&Param.5=&Param.6=&Param.7=&Param.8=&Param.9=&Param.10=&Param.11=&Param.12=&Param.13=&Param.14=&Param.15=&Param.16=&Param.17=&Param.18=&Param.19=&Param.20=&Param.21=&Param.22=&Param.23=&Param.24=&Param.25=&Param.26=&Param.27=&Param.28=&Param.29=&Param.30=&Param.31=&Param.32=&Query=select+%5BParam.2%5D+as+ITEM%2C+%5BParam.3%5D+as+ID+from+%5BParam.1%5D+where+enabled_ind+%3D+%271%27+order+by+ordr+asc&QueryParams=&NumberFormat=0.00&DateFormat=MM%2Fdd%2Fyyyy+HH%3Amm%3Ass&RowCount=500&Content-Type=text%2Fxml");

   phaseComboBox=new dhtmlXCombo("PhaseCombo","PhaseCombo",100);
   //phaseComboBox.enableFilteringMode(true);
   phaseComboBox.readonly(true);
   //phaseComboBox.loadXML("/Lighthammer/Illuminator?Connector=&Server=engsys&Service=&Mode=FixedQuery&Method=&CacheDurationUnits=M&CacheDuration=0&IsCachable=false&InlineTransform=http%3A%2F%2Flocalhost%2Fngc%2FXSLT%2FdhtmlxComboTransform.xsl&Param.1=tmse_pgmph_lt&Param.2=nm&Param.3=pgmph_id&Param.4=&Param.5=&Param.6=&Param.7=&Param.8=&Param.9=&Param.10=&Param.11=&Param.12=&Param.13=&Param.14=&Param.15=&Param.16=&Param.17=&Param.18=&Param.19=&Param.20=&Param.21=&Param.22=&Param.23=&Param.24=&Param.25=&Param.26=&Param.27=&Param.28=&Param.29=&Param.30=&Param.31=&Param.32=&Query=select+%5BParam.2%5D+as+ITEM%2C+%5BParam.3%5D+as+ID+from+%5BParam.1%5D+where+enabled_ind+%3D+%271%27+order+by+ordr+asc&QueryParams=&NumberFormat=0.00&DateFormat=MM%2Fdd%2Fyyyy+HH%3Amm%3Ass&RowCount=500&Content-Type=text%2Fxml");

   campComboBox=new dhtmlXCombo("CampCombo","CampCombo",200);
   //campComboBox.enableFilteringMode(true);
   campComboBox.readonly(true);
   //campComboBox.loadXML("/Lighthammer/Illuminator?Connector=&Server=engsys&Service=&Mode=FixedQuery&Method=&CacheDurationUnits=M&CacheDuration=0&IsCachable=false&InlineTransform=http%3A%2F%2Flocalhost%2Fngc%2FXSLT%2FdhtmlxComboTransform.xsl&Param.1=tmse_camp_lt&Param.2=nm&Param.3=camp_id&Param.4=&Param.5=&Param.6=&Param.7=&Param.8=&Param.9=&Param.10=&Param.11=&Param.12=&Param.13=&Param.14=&Param.15=&Param.16=&Param.17=&Param.18=&Param.19=&Param.20=&Param.21=&Param.22=&Param.23=&Param.24=&Param.25=&Param.26=&Param.27=&Param.28=&Param.29=&Param.30=&Param.31=&Param.32=&Query=select+%5BParam.2%5D+as+ITEM%2C+%5BParam.3%5D+as+ID+from+%5BParam.1%5D+where+enabled_ind+%3D+%271%27+order+by+ordr+asc&QueryParams=&NumberFormat=0.00&DateFormat=MM%2Fdd%2Fyyyy+HH%3Amm%3Ass&RowCount=500&Content-Type=text%2Fxml");

   window.dhx_globalImgPath="/wlibs/script/dhtmlx/dhtmlxCalendar/codebase/imgs/";
   
   effectStart = new dhtmlxCalendarObject("EffectStart",false, {isWinHeader:true,isWinDrag:true,isYearEditable:true,isMonthEditable:true});
   effectStart.setDateFormat("%Y-%m-%d");
   effectStart.winTitle = "EFFECT START";
   effectStart.draw();

   effectEnd = new dhtmlxCalendarObject("EffectEnd",false, {isWinHeader:true,isWinDrag:true,isYearEditable:true,isMonthEditable:true});
   effectEnd.setDateFormat("%Y-%m-%d");
   effectEnd.winTitle = "EFFECT END";
   effectEnd.draw();

   //clearStatus(7000);
}


function showSearchForm() {
   document.getElementById("FilterBoxGroupTitleId").style.display = "block";
   document.getElementById("FilterBoxGroupId").style.display = "block";
   document.getElementById("SearchHideLinkId").style.display = "inline";
   document.getElementById("SearchLinkId").style.display = "none";
   document.getElementById("SearchButtonBoxGroupId").style.display = "block";
}

function hideSearchForm() {
   document.getElementById("FilterBoxGroupTitleId").style.display = "none";
   document.getElementById("FilterBoxGroupId").style.display = "none";
   document.getElementById("SearchLinkId").style.display = "inline";
   document.getElementById("SearchHideLinkId").style.display = "none";
   document.getElementById("SearchButtonBoxGroupId").style.display = "none";
}

function hidePgmDetailForm() {
   document.getElementById("PgmDetailBoxGroupTitleId").style.display = "none";
   document.getElementById("PgmDetailBoxGroupId").style.display = "none";
   document.getElementById("PgmDetailLinkId").style.display = "inline";
   document.getElementById("PgmDetailHideLinkId").style.display = "none";
   document.getElementById("PgmCreateButtonBoxGroupId").style.display = "none";
}

function showPgmDetailForm() {
   document.getElementById("PgmDetailBoxGroupTitleId").style.display = "block";
   document.getElementById("PgmDetailBoxGroupId").style.display = "block";
   document.getElementById("PgmDetailLinkId").style.display = "none";
   document.getElementById("PgmDetailHideLinkId").style.display = "inline";
   document.getElementById("PgmCreateButtonBoxGroupId").style.display = "block";
   document.getElementById("PgmUpdateButtonId").style.display = "none";
}



function clearForm() {
   shortNmElem.setValue("");
   fullNmElem.setValue("");
   descrElem.setValue("");
   effectStartElem.setValue("");
   effectEndElem.setValue("");
   pgmComboBox.setComboText("");
   custComboBox.setComboText("");
   campComboBox.setComboText("");
   phaseComboBox.setComboText("");
   busaComboBox.setComboText("");
   perfSysComboBox.setComboText("");
   stateComboBox.setComboText("");
   visLvlComboBox.setComboText("");
   document.getElementById("MgmtPlan").checked = 0;
   document.getElementById("ReportCrd").checked = 0;
   document.getElementById("PgmUpdateButtonId").style.display = "none";
}

function updatePgm() {
   var rowId = pgmGrid.getSelectedRowId();
   if (rowId == null || rowId < 0) {
      alert("ERROR: A program record must be selected before an update can be performed.");
	  return;
   }
   if (!shortNmElem.isValidAlert() || !fullNmElem.isValidAlert() || !descrElem.isValidAlert() || !effectStartElem.isValidAlert() || !effectEndElem.isValidAlert()) {
     return;
   }
 
   if (campComboBox.getSelectedIndex() == -1
	|| custComboBox.getSelectedIndex() == -1
	|| busaComboBox.getSelectedIndex() == -1
	|| phaseComboBox.getSelectedIndex() == -1
	|| perfSysComboBox.getSelectedIndex() == -1
	|| visLvlComboBox.getSelectedIndex() == -1
	|| stateComboBox.getSelectedIndex() == -1 ) {
	   alert("ERROR:  A selection must be made for all drop-downs.");
	   return;
   }
	   
   document.getElementById("PgmUpdateButtonId").style.display = "none";

   var stateId = stateComboBox.getSelectedValue();
   var visLvlId = visLvlComboBox.getSelectedValue();
   var perfSysId = perfSysComboBox.getSelectedValue();
   
   var mgmtPlan = document.getElementById("MgmtPlan").checked;
   if (mgmtPlan) mgmtPlan = 1; else mgmtPlan = 0;
   
   var rptCrd = document.getElementById("ReportCrd").checked;
   if (rptCrd) rptCrd = 1; else rptCrd = 0;

   var campId = campComboBox.getSelectedValue();
   var custId = custComboBox.getSelectedValue();
   var busaId = busaComboBox.getSelectedValue();
   var phaseId = phaseComboBox.getSelectedValue();
   
   var effectStart = document.getElementById("EffectStart").value;
   var effectEnd = document.getElementById("EffectEnd").value;
 
   document.cmdApp.setQueryTemplate("engOps/updatePgm");
   var queryObj = document.cmdApp.getQueryObject();

   var personModr = document.getElementById("loginName").value;
   personModr = StringUtils.normalize(personModr);
   
   //alert("shotrNm=" + shortNmElem.getValue());
   
   queryObj.setParam(1, shortNmElem.getValue());
   queryObj.setParam(2, fullNmElem.getValue());
   queryObj.setParam(3, StringUtils.convertForSQL(descrElem.getValue()));
   queryObj.setParam(4, stateId);
   queryObj.setParam(5, visLvlId);
   queryObj.setParam(6, perfSysId);
   queryObj.setParam(7, mgmtPlan);
   queryObj.setParam(8, rptCrd);
   queryObj.setParam(9, personModr);
   queryObj.setParam(10, personModr);
   queryObj.setParam(11, campId);
   queryObj.setParam(12, custId);
   queryObj.setParam(13, busaId);
   queryObj.setParam(14, phaseId);
   queryObj.setParam(15, effectStart);
   queryObj.setParam(16, effectEnd);
   queryObj.setParam(17, rowId);

   var worked = cmdApp.executeCommand();
   if (worked) {
      //alert("Program successfully added.");
      // update program grid
	  pgmGrid.clearAll();
      pgmGrid.load("/Lighthammer/Illuminator?Connector=&Server=engsys&Service=&Mode=FixedQuery&Method=&CacheDurationUnits=M&CacheDuration=0&IsCachable=false&InlineTransform=http%3A%2F%2Flocalhost%2Fngc%2FXSLT%2FdhtmlxTransform.xsl&Param.1=&Param.2=&Param.3=&Param.4=&Param.5=&Param.6=&Param.7=&Param.8=&Param.9=&Param.10=&Param.11=&Param.12=&Param.13=&Param.14=&Param.15=&Param.16=&Param.17=&Param.18=&Param.19=&Param.20=&Param.21=&Param.22=&Param.23=&Param.24=&Param.25=&Param.26=&Param.27=&Param.28=&Param.29=&Param.30=&Param.31=&Param.32="
                + "&Query=select+pgm_id+as+id%2C++tmse_pgm.short_nm%2C+tmse_pgm.full_nm%2C+tmse_pgm.descr%2C+tmse_cust_lt.nm+as+customer%2C+tmse_pgmph_lt.nm+as+phase%2C+tmse_camp_lt.nm+as+campus%2C+%0D%0A+to_char%28eff_start_dtm%2C+%27yyyy-mm-dd%27%29+as+eff_start_dtm%2C+to_char%28eff_end_dtm%2C+%27yyyy-mm-dd%27%29+as+eff_end_dtm%2C+to_char%28tmse_pgm.mod_dtm%2C+%27yyyy-mm-dd+hh24%3Amm%3Ass%27%29%2C+tmse_pgm.person_modr%2C%0D%0A+tmse_state_lt.nm%2C+tmse_vislvl_lt.nm%2C+tmse_busa_lt.nm%2C+tmse_perfs_lt.nm%2C++tmse_pgm.mngmnt_plan_ind%2C+tmse_pgm.rpt_crd_ind%0D%0A++from+tmse_pgm%2C+tmse_pgmph_lt%2C+tmse_camp_lt%2C+tmse_cust_lt%2C+tmse_state_lt%2C+tmse_vislvl_lt%2C+tmse_busa_lt%2C+tmse_perfs_lt%0D%0A+where+%28%28upper%28tmse_pgm.descr%29+like+upper%28%27%25%5BParam.1%5D%25%27%29%29+or+%28upper%28tmse_pgm.short_nm%29+like+upper%28%27%25%5BParam.1%5D%25%27%29%29+or+%28upper%28tmse_pgm.full_nm%29+like+upper%28%27%25%5BParam.1%5D%25%27%29%29%29+and+tmse_pgm.pgmph_id+%3D+tmse_pgmph_lt.pgmph_id+and%0D%0Atmse_pgm.camp_id+%3D+tmse_camp_lt.camp_id++and+tmse_pgm.cust_id+%3D+tmse_cust_lt.cust_id+%0D%0Aand+tmse_pgm.state_id+%3D+tmse_state_lt.state_id+%0D%0Aand+tmse_pgm.vislvl_id+%3D+tmse_vislvl_lt.vislvl_id+%0D%0Aand+tmse_pgm.busa_id+%3D+tmse_busa_lt.busa_id+%0D%0Aand+tmse_pgm.perfs_id+%3D+tmse_perfs_lt.perfs_id+%0D%0Aorder+by+short_nm"
				+ "&QueryParams=&NumberFormat=0.00&DateFormat=MM%2Fdd%2Fyyyy+HH%3Amm%3Ass&RowCount=100&Content-Type=text%2Fxml","xml");
   } else {
      var lastErr = cmdApp.getLastError();
	 //if (lastErr.indexOf("ORA-00001") > 0) {
	 //    alert("ERROR: Short name and full name must be unique.");
	 // } else {
        alert("ERROR: An error occurred while attempting to create records. Last error was: " + lastErr);
	 // }
   }

}

function createPgm() {
   
   if (!shortNmElem.isValidAlert() || !fullNmElem.isValidAlert() || !descrElem.isValidAlert() || !effectStartElem.isValidAlert() || !effectEndElem.isValidAlert()) {
     return;
   }
 
   if (campComboBox.getSelectedIndex() == -1
	|| custComboBox.getSelectedIndex() == -1
	|| busaComboBox.getSelectedIndex() == -1
	|| phaseComboBox.getSelectedIndex() == -1
	|| perfSysComboBox.getSelectedIndex() == -1
	|| visLvlComboBox.getSelectedIndex() == -1
	|| stateComboBox.getSelectedIndex() == -1 ) {
	   alert("ERROR:  A selection must be made for all drop-downs.");
	   return;
   }
	   
   var stateId = stateComboBox.getSelectedValue();
   var visLvlId = visLvlComboBox.getSelectedValue();
   var perfSysId = perfSysComboBox.getSelectedValue();
   
   var mgmtPlan = document.getElementById("MgmtPlan").checked;
   if (mgmtPlan) mgmtPlan = 1; else mgmtPlan = 0;
   
   var rptCrd = document.getElementById("ReportCrd").checked;
   if (rptCrd) rptCrd = 1; else rptCrd = 0;

   var campId = campComboBox.getSelectedValue();
   var custId = custComboBox.getSelectedValue();
   var busaId = busaComboBox.getSelectedValue();
   var phaseId = phaseComboBox.getSelectedValue();
   
   var effectStart = document.getElementById("EffectStart").value;
   var effectEnd = document.getElementById("EffectEnd").value;
 
   document.cmdApp.setQueryTemplate("engOps/insertPgm");
   var queryObj = document.cmdApp.getQueryObject();

   var personModr = document.getElementById("loginName").value;
   personModr = StringUtils.normalize(personModr);
   
   queryObj.setParam(1, shortNmElem.getValue());
   queryObj.setParam(2, fullNmElem.getValue());
   queryObj.setParam(3, StringUtils.convertForSQL(descrElem.getValue()));
   queryObj.setParam(4, stateId);
   queryObj.setParam(5, visLvlId);
   queryObj.setParam(6, perfSysId);
   queryObj.setParam(7, mgmtPlan);
   queryObj.setParam(8, rptCrd);
   queryObj.setParam(9, personModr);
   queryObj.setParam(10, personModr);
   queryObj.setParam(11, campId);
   queryObj.setParam(12, custId);
   queryObj.setParam(13, busaId);
   queryObj.setParam(14, phaseId);
   queryObj.setParam(15, effectStart);
   queryObj.setParam(16, effectEnd);

   var worked = cmdApp.executeCommand();
   if (worked) {
      //alert("Program successfully added.");
      // update program grid
	  pgmGrid.clearAll();
      pgmGrid.load("/Lighthammer/Illuminator?Connector=&Server=engsys&Service=&Mode=FixedQuery&Method=&CacheDurationUnits=M&CacheDuration=0&IsCachable=false&InlineTransform=http%3A%2F%2Flocalhost%2Fngc%2FXSLT%2FdhtmlxTransform.xsl&Param.1=&Param.2=&Param.3=&Param.4=&Param.5=&Param.6=&Param.7=&Param.8=&Param.9=&Param.10=&Param.11=&Param.12=&Param.13=&Param.14=&Param.15=&Param.16=&Param.17=&Param.18=&Param.19=&Param.20=&Param.21=&Param.22=&Param.23=&Param.24=&Param.25=&Param.26=&Param.27=&Param.28=&Param.29=&Param.30=&Param.31=&Param.32="
                + "&Query=select+pgm_id+as+id%2C++tmse_pgm.short_nm%2C+tmse_pgm.full_nm%2C+tmse_pgm.descr%2C+tmse_cust_lt.nm+as+customer%2C+tmse_pgmph_lt.nm+as+phase%2C+tmse_camp_lt.nm+as+campus%2C+%0D%0A+to_char%28eff_start_dtm%2C+%27yyyy-mm-dd%27%29+as+eff_start_dtm%2C+to_char%28eff_end_dtm%2C+%27yyyy-mm-dd%27%29+as+eff_end_dtm%2C+to_char%28tmse_pgm.mod_dtm%2C+%27yyyy-mm-dd+hh24%3Amm%3Ass%27%29%2C+tmse_pgm.person_modr%2C%0D%0A+tmse_state_lt.nm%2C+tmse_vislvl_lt.nm%2C+tmse_busa_lt.nm%2C+tmse_perfs_lt.nm%2C++tmse_pgm.mngmnt_plan_ind%2C+tmse_pgm.rpt_crd_ind%0D%0A++from+tmse_pgm%2C+tmse_pgmph_lt%2C+tmse_camp_lt%2C+tmse_cust_lt%2C+tmse_state_lt%2C+tmse_vislvl_lt%2C+tmse_busa_lt%2C+tmse_perfs_lt%0D%0A+where+%28%28upper%28tmse_pgm.descr%29+like+upper%28%27%25%5BParam.1%5D%25%27%29%29+or+%28upper%28tmse_pgm.short_nm%29+like+upper%28%27%25%5BParam.1%5D%25%27%29%29+or+%28upper%28tmse_pgm.full_nm%29+like+upper%28%27%25%5BParam.1%5D%25%27%29%29%29+and+tmse_pgm.pgmph_id+%3D+tmse_pgmph_lt.pgmph_id+and%0D%0Atmse_pgm.camp_id+%3D+tmse_camp_lt.camp_id++and+tmse_pgm.cust_id+%3D+tmse_cust_lt.cust_id+%0D%0Aand+tmse_pgm.state_id+%3D+tmse_state_lt.state_id+%0D%0Aand+tmse_pgm.vislvl_id+%3D+tmse_vislvl_lt.vislvl_id+%0D%0Aand+tmse_pgm.busa_id+%3D+tmse_busa_lt.busa_id+%0D%0Aand+tmse_pgm.perfs_id+%3D+tmse_perfs_lt.perfs_id+%0D%0Aorder+by+short_nm"
				+ "&QueryParams=&NumberFormat=0.00&DateFormat=MM%2Fdd%2Fyyyy+HH%3Amm%3Ass&RowCount=100&Content-Type=text%2Fxml","xml");
   } else {
      var lastErr = cmdApp.getLastError();
	  if (lastErr.indexOf("ORA-00001") > 0) {
	     alert("ERROR: Short name and full name must be unique.");
	  } else {
        alert("ERROR: An error occurred while attempting to create records. Last error was: " + lastErr);
	  }
   }

}

function showAllPgms() {
  pgmComboBox.setComboText("");
  searchProgs();
}

function searchProgs() {
   var programTxt= pgmComboBox.getComboText();
   programTxt = StringUtils.trim(programTxt);
   
   if (programTxt == null || programTxt == "") {
      document.getElementById("PgmShowAllLinkId").style.display = "none";
   } else {
      document.getElementById("PgmShowAllLinkId").style.display = "inline";
   }

   pgmGrid.clearAll();
   pgmGrid.load("/Lighthammer/Illuminator?Connector=&Server=engsys&Service=&Mode=FixedQuery&Method=&CacheDurationUnits=M&CacheDuration=0&IsCachable=false&InlineTransform=http%3A%2F%2Flocalhost%2Fngc%2FXSLT%2FdhtmlxTransform.xsl&Param.1=" + programTxt  + "&Param.2=&Param.3=&Param.4=&Param.5=&Param.6=&Param.7=&Param.8=&Param.9=&Param.10=&Param.11=&Param.12=&Param.13=&Param.14=&Param.15=&Param.16=&Param.17=&Param.18=&Param.19=&Param.20=&Param.21=&Param.22=&Param.23=&Param.24=&Param.25=&Param.26=&Param.27=&Param.28=&Param.29=&Param.30=&Param.31=&Param.32="
                + "&Query=select+pgm_id+as+id%2C++tmse_pgm.short_nm%2C+tmse_pgm.full_nm%2C+tmse_pgm.descr%2C+tmse_cust_lt.nm+as+customer%2C+tmse_pgmph_lt.nm+as+phase%2C+tmse_camp_lt.nm+as+campus%2C+%0D%0A+to_char%28eff_start_dtm%2C+%27yyyy-mm-dd%27%29+as+eff_start_dtm%2C+to_char%28eff_end_dtm%2C+%27yyyy-mm-dd%27%29+as+eff_end_dtm%2C+to_char%28tmse_pgm.mod_dtm%2C+%27yyyy-mm-dd+hh24%3Amm%3Ass%27%29%2C+tmse_pgm.person_modr%2C%0D%0A+tmse_state_lt.nm%2C+tmse_vislvl_lt.nm%2C+tmse_busa_lt.nm%2C+tmse_perfs_lt.nm%2C++tmse_pgm.mngmnt_plan_ind%2C+tmse_pgm.rpt_crd_ind%0D%0A++from+tmse_pgm%2C+tmse_pgmph_lt%2C+tmse_camp_lt%2C+tmse_cust_lt%2C+tmse_state_lt%2C+tmse_vislvl_lt%2C+tmse_busa_lt%2C+tmse_perfs_lt%0D%0A+where+%28%28upper%28tmse_pgm.descr%29+like+upper%28%27%25%5BParam.1%5D%25%27%29%29+or+%28upper%28tmse_pgm.short_nm%29+like+upper%28%27%25%5BParam.1%5D%25%27%29%29+or+%28upper%28tmse_pgm.full_nm%29+like+upper%28%27%25%5BParam.1%5D%25%27%29%29%29+and+tmse_pgm.pgmph_id+%3D+tmse_pgmph_lt.pgmph_id+and%0D%0Atmse_pgm.camp_id+%3D+tmse_camp_lt.camp_id++and+tmse_pgm.cust_id+%3D+tmse_cust_lt.cust_id+%0D%0Aand+tmse_pgm.state_id+%3D+tmse_state_lt.state_id+%0D%0Aand+tmse_pgm.vislvl_id+%3D+tmse_vislvl_lt.vislvl_id+%0D%0Aand+tmse_pgm.busa_id+%3D+tmse_busa_lt.busa_id+%0D%0Aand+tmse_pgm.perfs_id+%3D+tmse_perfs_lt.perfs_id+%0D%0Aorder+by+short_nm"
				+ "&QueryParams=&NumberFormat=0.00&DateFormat=MM%2Fdd%2Fyyyy+HH%3Amm%3Ass&RowCount=100&Content-Type=text%2Fxml","xml");
}
/*
function searchProgs() {
   var programTxt= pgmComboBox.getComboText();
   alert("programTxt=" + programTxt);
   if (programTxt == null || programTxt == "") {
      document.getElementById("PgmShowAllLinkId").style.display = "none";
   } else {
      document.getElementById("PgmShowAllLinkId").style.display = "inline";
   }
   pgmGrid.clearAll();
   pgmGrid.load("/Lighthammer/Illuminator?Connector=&Server=engsys&Service=&Mode=FixedQuery&Method=&CacheDurationUnits=M&CacheDuration=0&IsCachable=false&InlineTransform=http%3A%2F%2Flocalhost%2Fngc%2FXSLT%2FdhtmlxTransform.xsl&Param.1=" + programTxt  + "&Param.2=&Param.3=&Param.4=&Param.5=&Param.6=&Param.7=&Param.8=&Param.9=&Param.10=&Param.11=&Param.12=&Param.13=&Param.14=&Param.15=&Param.16=&Param.17=&Param.18=&Param.19=&Param.20=&Param.21=&Param.22=&Param.23=&Param.24=&Param.25=&Param.26=&Param.27=&Param.28=&Param.29=&Param.30=&Param.31=&Param.32="
                + "&Query=select+pgm_id+as+id%2C++tmse_pgm.short_nm%2C+tmse_pgm.full_nm%2C+tmse_pgm.descr%2C+tmse_cust_lt.nm+as+customer%2C+tmse_pgmph_lt.nm+as+phase%2C+tmse_camp_lt.nm+as+campus%2C+%0D%0A+to_char%28eff_start_dtm%2C+%27yyyy-mm-dd%27%29+as+eff_start_dtm%2C+to_char%28eff_end_dtm%2C+%27yyyy-mm-dd%27%29+as+eff_end_dtm%2C+to_char%28tmse_pgm.mod_dtm%2C+%27yyyy-mm-dd+hh24%3Amm%3Ass%27%29%2C+tmse_pgm.person_modr%2C%0D%0A+tmse_state_lt.nm%2C+tmse_vislvl_lt.nm%2C+tmse_busa_lt.nm%2C+tmse_perfs_lt.nm%2C++tmse_pgm.mngmnt_plan_ind%2C+tmse_pgm.rpt_crd_ind%0D%0A++from+tmse_pgm%2C+tmse_pgmph_lt%2C+tmse_camp_lt%2C+tmse_cust_lt%2C+tmse_state_lt%2C+tmse_vislvl_lt%2C+tmse_busa_lt%2C+tmse_perfs_lt%0D%0A+where+%28%28upper%28tmse_pgm.descr%29+like+upper%28%27%25%5BParam.1%5D%25%27%29%29+or+%28upper%28tmse_pgm.short_nm%29+like+upper%28%27%25%5BParam.1%5D%25%27%29%29+or+%28upper%28tmse_pgm.full_nm%29+like+upper%28%27%25%5BParam.1%5D%25%27%29%29%29+and+tmse_pgm.pgmph_id+%3D+tmse_pgmph_lt.pgmph_id+and%0D%0Atmse_pgm.camp_id+%3D+tmse_camp_lt.camp_id++and+tmse_pgm.cust_id+%3D+tmse_cust_lt.cust_id+%0D%0Aand+tmse_pgm.state_id+%3D+tmse_state_lt.state_id+%0D%0Aand+tmse_pgm.vislvl_id+%3D+tmse_vislvl_lt.vislvl_id+%0D%0Aand+tmse_pgm.busa_id+%3D+tmse_busa_lt.busa_id+%0D%0Aand+tmse_pgm.perfs_id+%3D+tmse_perfs_lt.perfs_id+%0D%0Aorder+by+short_nm"
				+ "&QueryParams=&NumberFormat=0.00&DateFormat=MM%2Fdd%2Fyyyy+HH%3Amm%3Ass&RowCount=100&Content-Type=text%2Fxml","xml");
}
*/

function doOnRowSelected() {
   var rowId = pgmGrid.getSelectedRowId();
   //pgmGrid.setRowColor(rowId, "#ccccc");
   pgm.id = rowId;
   pgm.shortNm = pgmGrid.cellById(rowId, pgmGrid.getColIndexById("NM")).getValue();
   //pgm.shortNm = pgmGrid.cellById(rowId, 0).getValue();
   pgm.fullNm = pgmGrid.cellById(rowId, 1).getValue();
   pgm.descr = pgmGrid.cellById(rowId, 2).getValue();
   pgm.cust = pgmGrid.cellById(rowId, 3).getValue();
   pgm.phase = pgmGrid.cellById(rowId, 4).getValue();
   pgm.camp = pgmGrid.cellById(rowId, 5).getValue();
   pgm.effectStart = pgmGrid.cellById(rowId, 6).getValue();
   pgm.effectEnd = pgmGrid.cellById(rowId, 7).getValue();
   pgm.modDtm = pgmGrid.cellById(rowId, 8).getValue();
   pgm.personModr = pgmGrid.cellById(rowId, 9).getValue();
   pgm.state = pgmGrid.cellById(rowId, 10).getValue();
   pgm.visLvl = pgmGrid.cellById(rowId, 11).getValue();
   pgm.busArea = pgmGrid.cellById(rowId, 12).getValue();
   pgm.perfSys = pgmGrid.cellById(rowId, 13).getValue();
   pgm.mgmntPlan = pgmGrid.cellById(rowId, 14).getValue();
   pgm.rptCrd = pgmGrid.cellById(rowId, 15).getValue();
   
   if (pgm.rptCrd == "1") document.getElementById("ReportCrd").checked = 1; else document.getElementById("ReportCrd").checked = 0;
   if (pgm.mgmntPlan == "1") document.getElementById("MgmtPlan").checked = 1; else document.getElementById("MgmtPlan").checked = 0;
    
   shortNmElem.setValue(pgm.shortNm);
   fullNmElem.setValue(pgm.fullNm);
   descrElem.setValue(pgm.descr);
   effectStartElem.setValue(pgm.effectStart);
   effectEndElem.setValue(pgm.effectEnd);
  //pgm.alertAll();
   document.getElementById("PgmUpdateButtonId").style.display = "inline";
   
   var option = campComboBox.getOptionByLabel(pgm.camp);
   campComboBox.selectOption(campComboBox.getIndexByValue(option.value), true, true);
  
   option = phaseComboBox.getOptionByLabel(pgm.phase);
   phaseComboBox.selectOption(phaseComboBox.getIndexByValue(option.value), true, true);
  
   option = custComboBox.getOptionByLabel(pgm.cust);
   custComboBox.selectOption(custComboBox.getIndexByValue(option.value), true, true);
  
   option = visLvlComboBox.getOptionByLabel(pgm.visLvl);
   visLvlComboBox.selectOption(visLvlComboBox.getIndexByValue(option.value), true, true);
  
   option = stateComboBox.getOptionByLabel(pgm.state);
   stateComboBox.selectOption(stateComboBox.getIndexByValue(option.value), true, true);
  
   option = perfSysComboBox.getOptionByLabel(pgm.perfSys);
   perfSysComboBox.selectOption(perfSysComboBox.getIndexByValue(option.value), true, true);
  
   option = busaComboBox.getOptionByLabel(pgm.busArea);
   busaComboBox.selectOption(busaComboBox.getIndexByValue(option.value), true, true);
   
}

/*
function doOnCellEdit() {
   //alert("doOnCellEdit");
}
function doOnEnter() {
   //alert("doOnEnter");
}
function doOnCheck() {
   //alert("doOnCheck");
}
function doBeforeRowDeleted() {
   //alert("doBeforeRowDeleted");
}
*/